% redefinition of left and right to make spacing consistent
\let\originalleft\left
\let\originalright\right
\def\left#1{\mathopen{}\originalleft#1}
\def\right#1{\originalright#1\mathclose{}}

\usepackage{amsmath}
\usepackage{amssymb}  % loads amsfonts

\usepackage{mathtools}  % \coloneqq
%\usepackage{bm}
%\usepackage[utopia]{mathdesign}
\usepackage[OMLmathsfit]{isomath}  % \DeclareMathAlphabet ...

\usepackage{mathtools}  % smashoperator
\usepackage{upgreek}

%\usepackage{commath}  % calculus, perentheses
% https://tex.stackexchange.com/questions/135944/commath-and-ifinner/135985#135985
%
\newcommand{\dif}{\mathop{}\!\mathrm{d}}
\newcommand{\Dif}{\mathop{}\!\mathrm{D}}

\makeatletter
\newcommand{\spx}[1]{%
	\if\relax\detokenize{#1}\relax
	\expandafter\@gobble
	\else
	\expandafter\@firstofone
	\fi
	{^{#1}}%
}
\makeatother

\newcommand\pd[3][]{\frac{\partial\spx{#1}#2}{\partial#3\spx{#1}}}
\newcommand\tpd[3][]{\tfrac{\partial\spx{#1}#2}{\partial#3\spx{#1}}}
\newcommand\dpd[3][]{\dfrac{\partial\spx{#1}#2}{\partial#3\spx{#1}}}

\newcommand{\md}[6]{\frac{\partial\spx{#2}#1}{\partial#3\spx{#4}\partial#5\spx{#6}}}
\newcommand{\tmd}[6]{\tfrac{\partial\spx{#2}#1}{\partial#3\spx{#4}\partial#5\spx{#6}}}
\newcommand{\dmd}[6]{\dfrac{\partial\spx{#2}#1}{\partial#3\spx{#4}\partial#5\spx{#6}}}

\newcommand{\od}[3][]{\frac{\dif\spx{#1}#2}{\dif#3\spx{#1}}}
\newcommand{\tod}[3][]{\tfrac{\dif\spx{#1}#2}{\dif#3\spx{#1}}}
\newcommand{\dod}[3][]{\dfrac{\dif\spx{#1}#2}{\dif#3\spx{#1}}}

\newcommand{\genericdel}[4]{%
	\ifcase#3\relax
	\ifx#1.\else#1\fi#4\ifx#2.\else#2\fi\or
	\bigl#1#4\bigr#2\or
	\Bigl#1#4\Bigr#2\or
	\biggl#1#4\biggr#2\or
	\Biggl#1#4\Biggr#2\else
	\left#1#4\right#2\fi
}
\newcommand{\del}[2][-1]{\genericdel(){#1}{#2}}
\newcommand{\set}[2][-1]{\genericdel\{\}{#1}{#2}}
\let\cbr\set
\let\event\set
\newcommand{\sbr}[2][-1]{\genericdel[]{#1}{#2}}
\let\intoo\del
\let\intcc\sbr
\newcommand{\intoc}[2][-1]{\genericdel(]{#1}{#2}}
\newcommand{\intco}[2][-1]{\genericdel[){#1}{#2}}
\newcommand{\eval}[2][-1]{\genericdel.|{#1}{#2}}
\newcommand{\envert}[2][-1]{\genericdel||{#1}{#2}}
\let\abs\envert
\newcommand{\sVert}[1][0]{%
	\ifcase#1\relax
	\rvert\or\bigr|\or\Bigr|\or\biggr|\or\Biggr
	\fi
}
\newcommand{\enVert}[2][-1]{\genericdel\|\|{#1}{#2}}
\let\norm\enVert
\newcommand{\fullfunction}[5]{%
	\begin{array}{@{}r@{}l@{}}
		#1 \colon #2 &{}\longrightarrow{}  #3 \\
		#4 &{}\longmapsto{} #5
	\end{array}
}
%
%


\usepackage{stmaryrd}  % \llbracket for \rrbracket, ...


%\usepackage[croatian]{babel}		% teorem
%\newtheorem{definition}{Definicija}[section]
%\newtheorem{theorem}{Teorem}[section]
%\newtheorem{corollary}{Korolar}[theorem]

\DeclareMathAlphabet{\mathbbmsl}{U}{bbm}{m}{sl}
\DeclareMathAlphabet{\mathbbmb}{U}{bbm}{b}{it}
\DeclareMathAlphabet{\mathbbmssit}{U}{bbmss}{m}{it}


% common set?, distribution
\newcommand{\commset}[1]{\mathbbmb{#1}}
\newcommand{\distrib}[1]{\mathcal{#1}}

% sans-serif blackboard-bold
\newcommand{\mathsfbbit}[1]{\mathbbmssit{#1}}

% variable
\let\vec\relax
\let\set\relax
\newcommand{\vec}[1]{\mathbfit{#1}}
\newcommand{\set}[1]{\mathbbmsl{#1}}

% constant
\newcommand{\const}[1]{\mathrm{#1}}
\newcommand{\cvec}[1]{\mathbf{#1}}
\newcommand{\cset}[1]{\mathbb{#1}}

% random variable
%\newcommand\mathmakebox[3][1em][c]{\mathpalette\mathmakeboxinternal[#1][#2]{#3}}
%\newcommand\mathmakeboxinternal[3][1em][c]{\makebox[#1][#2]{$\mathsurround=0pt{#3}$}}
\usepackage{etex}
\newcommand{\nunder}[2][5]{\mathrlap{\mkern\the\numexpr#1/2mu\relax\underline{\phantom{\mathrm{#2}\mkern-#1mu}}}\mathrm{#2}}
\newcommand{\subline}[2][n]{%
    \makebox[\widthof{$#2$}/2]{}\mathclap{#2}%
    \text{\smash{\raisebox{0.04em}{% 0.04
        $\mathclap{\underline{\hphantom{#1}\vphantom{#2}}}$%
    }}}%
    \makebox[\widthof{$#2$}/2]{}%
}
\newcommand{\rvarstyle}[1]{{{\subline[i]{#1}}}}
\newcommand{\rvar}[1]{\rvarstyle{#1}}
\newcommand{\rvec}[1]{\rvarstyle{\vec{#1}}}
\newcommand{\rset}[1]{\rvarstyle{\set{#1}}}
\newcommand{\var}[1]{{\color{red}#1}}

% linear algebra
\newcommand{\transpose}{\mathsf T}
\newcommand{\tp}{\transpose}

% calculus - commath: od, pd, md, dif
% parentheses - commath: del, cbr, sbr, envert, enVert

% named functions
\DeclareMathOperator{\softplus}{softplus}
\DeclareMathOperator{\softmax}{softmax}
\DeclareMathOperator{\logistic}{\sigma}
\DeclareMathOperator{\sgn}{sgn}
\DeclareMathOperator{\diag}{diag}
\DeclareMathOperator{\ReLU}{ReLU}
\DeclareMathOperator{\modfunc}{mod}

% operators
\DeclareMathOperator*{\argmin}{arg\,min} % thin space
\DeclareMathOperator*{\argmax}{arg\,max}
\let\P\relax
\newcommand{\P}{\mathrm{P}}
\newcommand{\p}{\mathrm{p}}
\DeclareMathOperator*{\E}{\mathrm{I\kern-.282em E}}
\DeclareMathOperator*{\D}{\mathrm{I\kern-.282em D}}
\DeclareMathOperator*{\Cov}{\mathrm{Cov}}
%\let\H\relax
\renewcommand{\H}{\mathrm{H}}
\newcommand{\h}{\mathrm{h}}
\newcommand{\I}{\mathrm{I}}
\newcommand{\Dist}{\mathrm{D}}  % D is for dispersion
%\renewcommand{\dif}{\mathrm{d}}

\newcommand{\pa}{\mathrm{pa}}
\newcommand{\ch}{\mathrm{ch}}
\newcommand{\pred}{\mathrm{pred}}
\renewcommand{\succ}{\mathrm{succ}}

\newcommand{\vecfunc}{\mathrm{vec}}

% bracket operators
%\newcommand{\enangle}[1]{\mathinner{\left\langle{#1}\right\rangle}}
\newcommand{\enangle}[2][-1]{\genericdel\langle\rangle{#1}{#2}}
\newcommand{\enbbracket}[1]{{\mathinner{\left\llbracket{#1}\right\rrbracket}}}
\newcommand{\braket}[2]{\enangle{{#1}\middle|{#2}}}

% parentheses from commath redefined to improve spacing because left and right were redefined, \midmid, new \tilde and \hat that don't make parentheses bigger
\renewcommand{\del}[1]{\left(#1\right)}
\renewcommand{\sbr}[1]{\left[#1\right]}
\renewcommand{\cbr}[1]{\left\{#1\right\}}
\renewcommand{\intoo}[1]{\mathinner{\del{#1}}}
\renewcommand{\intcc}[1]{\mathinner{\sbr{#1}}}
\renewcommand{\intco}[1]{\mathinner{\left[#1\right)}}
\renewcommand{\intoc}[1]{\mathinner{\left(#1\right]}}
\newcommand{\ind}[1]{{\sbr{#1}}}
%\let\mid\relax
%\newcommand{\mid}{\;|\;}  % spaces around not reduced in index
\newcommand{\midmid}{\;\middle|\;}
\let\oldhat\hat
\renewcommand{\hat}[1]{\vphantom{#1}\smash[t]{\oldhat{#1}}}
\let\oldtilde\tilde
\renewcommand{\tilde}[1]{\vphantom{#1}\smash[t]{\oldtilde{#1}}}
%\renewcommand{\tilde}[1]{\stackrel{\sim}{\smash{\mathcal{#1}}\rule{0pt}{1.1ex}}}
%\renewcommand{\tilde}[1]{\overset{\sim}{#1}}}
\let\oldwidetilde\widetilde
\renewcommand{\widetilde}[1]{\vphantom{#1}\smash[t]{\oldwidetilde{#1}}}

% special
%\newcommand{\funcdef}[3]{#1 \in (#2 \to #3)}
\newcommand{\funcdef}[3]{#1 \colon #2 \to #3}
\newcommand{\Dkl}[2]{\Dist_\mathrm{KL}\del{#1\;\middle\|\;#2}}
\newcommand{\C}{\cset{C}}
\newcommand{\R}{\cset{R}}
\newcommand{\Z}{\cset{Z}}
\newcommand{\N}{\cset{N}}
\newcommand{\dirac}{\updelta}

\newcommand\concat{\mathbin{+\mkern-10mu+}}

\newcommand{\TP}{\mathit{TP}}
\newcommand{\FP}{\mathit{FP}}
\newcommand{\TN}{\mathit{TN}}
\newcommand{\FN}{\mathit{FN}}
\newcommand{\FPR}{\mathit{FPR}}
\newcommand{\TPR}{\mathit{TPR}}
\newcommand{\AUROC}{\mathit{AUROC}}
\newcommand{\AUPR}{\mathit{AUPR}}
\newcommand{\AP}{\mathit{AP}}
\newcommand{\IoU}{\mathit{IoU}}
\newcommand{\mIoU}{\mathit{mIoU}}

% operators and relations
\newcommand{\bidot}{\mkern1.5mu{..}\mkern1.5mu}
%\newcommand\sheq{\mkern1.5mu{=}\mkern1.5mu}
%\renewcommand{\dots}{...}


% no vertical space stretching around display math
\usepackage[nodisplayskipstretch]{setspace}

\newenvironment{talign}
{\let\displaystyle\textstyle\align}
{\endalign}
\newenvironment{talign*}
{\let\displaystyle\textstyle\csname align*\endcsname}
{\endalign}


\usepackage{dashbox}%
%\newcommand\dashedbox[1][H]{\setlength{\fboxsep}{0pt}\setlength{\dashlength}{4pt}\setlength{\dashdash}{2pt} \dbox{\phantom{#1}}}
\newcommand\phbox[1][\phantom{:}]{\setlength{\fboxsep}{0.5pt}\setlength{\dashlength}{4pt}\setlength{\dashdash}{3pt} \raisebox{2pt}{\dbox{$\phantom{:}_{#1}$}}}
%\newcommand\dashedbox[1][H]{\setlength{\fboxsep}{0pt}\dbox{\phantom{#1}}}
